#include <iostream>


#include "image.hpp"

Color myfunc(Color c) { return c * 10; }

int main(int argc,char **argv)
{
	std::cout << "Image processing\n********************" << std::endl;
	if(argc < 3)
	{
		std::cerr << "Parameter missing, usage:\n  app image.tga image2.tga" << std::endl;
		return 1;
	}

	const char* input_image = argv[1];
	const char* output_image = argv[2];

	Image img;
	if( img.loadTGA(input_image) == false )
	{
		std::cerr << "Error: image not found: " << input_image << std::endl;
		return 1;
	}

	std::cout << "Image info:\n + Width: " << img.width << "\n + Height: " << img.height << std::endl;

	//inverse pixels
	img.forEachPixel( [](Color c) { return Color(1,1,1) - c; });

	//swap channels
	img.forEachPixel( [](Color c) { return Color(c.b,c.g,c.r); });

	//save
	img.saveTGA(output_image);

	std::cout << "Done" << std::endl;
	return 0;
}